/* 
 * jsgb.debugger.js v0.01 - Debugger for JSGB, a GameBoy Emulator
 * Copyright (C) 2009 Pedro Ladaria <Sonic1980 at Gmail dot com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 * The full license is available at http://www.gnu.org/licenses/gpl.html
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 */
 
function dump_all() {
  dump_cpu();
  dump_spr();
  //asmScroll.dragger.posY*(0xFFFF-dump_asm_h+1)
  asmScroll.dragger.setpos(0,((PC-10<0)?0:(PC-10))/(0xFFFF-dump_asm_h+1));
  dump_asm();
  dump_mem();
  memScroll.update();
  asmScroll.update();
  dump_bg();
  dump_sp();
  draw_tiles();
  draw_background();
}

// CPU //

function dump_cpu() {
  $('RA').innerHTML='A: '+zf(hex(RA),2)+br+sp(zf(bin(RA),8),4);
  $('RB').innerHTML='B: '+zf(hex(RB),2)+br+sp(zf(bin(RB),8),4);
  $('RC').innerHTML='C: '+zf(hex(RC),2)+br+sp(zf(bin(RC),8),4);
  $('RD').innerHTML='D: '+zf(hex(RD),2)+br+sp(zf(bin(RD),8),4);
  $('RE').innerHTML='E: '+zf(hex(RE),2)+br+sp(zf(bin(RE),8),4);
  $('HL').innerHTML='&nbsp;HL: '+zf(hex(HL),4)+br+sp(zf(bin(HL),16),4);
  $('SP').innerHTML='&nbsp;SP: '+zf(hex(SP),4)+br+sp(zf(bin(SP),16),4);
  $('PC').innerHTML='&nbsp;PC: '+zf(hex(PC),4)+br+sp(zf(bin(PC),16),4);
  $('RF').innerHTML='Z:'+(0+FZ)+' N:'+(0+FN)+'<br/'+'>H:'+(0+FH)+' C:'+(0+FC);
}

// SPECIAL REGISTERS //

function dump_spr() {
  $('SPRDUMP').innerHTML=
    'FF00:P1&nbsp; &nbsp;'+sp(zf(bin(MEM[0xFF00]),8),4)+br+
    'FF04:DIV&nbsp; '     +MEM[0xFF04]+'=0x'+zf(hex(MEM[0xFF04]),2)+br+
    'FF05:TIMA '          +MEM[0xFF05]+'=0x'+zf(hex(MEM[0xFF05]),2)+br+
    'FF06:TMA &nbsp;'     +MEM[0xFF06]+'=0x'+zf(hex(MEM[0xFF06]),2)+br+
    'FF07:TAC&nbsp; '     +sp(zf(bin(MEM[0xFF07]),8),4)+br+
    'FF0F:IF&nbsp; &nbsp;'+sp(zf(bin(MEM[0xFF0F]),8),4)+br+
    'FF40:LCDC '          +sp(zf(bin(MEM[0xFF40]),8),4)+br+
    'FF41:STAT '          +sp(zf(bin(MEM[0xFF41]),8),4)+br+
    'FF42:SCY&nbsp; '     +MEM[0xFF42]+br+
    'FF43:SCX&nbsp; '     +MEM[0xFF43]+br+
    'FF44:LY&nbsp; &nbsp;'+MEM[0xFF44]+br+
    'FF45:LYC &nbsp;'     +MEM[0xFF45]+br+

    'FF46:DMA &nbsp;'     +'0x'+zf(hex(MEM[0xFF46]),2)+br+
    'FF47:BGP &nbsp;'     +sp(zf(bin(MEM[0xFF47]),8),4)+br+
    'FF48:OBP0&nbsp;'     +sp(zf(bin(MEM[0xFF48]),8),4)+br+
    'FF49:OBP1&nbsp;'     +sp(zf(bin(MEM[0xFF49]),8),4)+br+

    'FF4A:WX&nbsp; &nbsp;'+MEM[0xFF4A]+br+
    'FF4B:WY&nbsp; &nbsp;'+MEM[0xFF4B]+br+
    'FFFF:IE&nbsp; &nbsp;'+sp(zf(bin(MEM[0xFFFF]),8),4)+br+
    '<hr>'+
    'Emulator vars'+br+
    'IME: '+IME+br+
    'ICC: '+ICC+br+
    'DCC: '+DCC+br+
    'SLC: '+SLC+br;
}

// MEMORY //

var dump_mem_w=16;
var dump_mem_h=40;
var dump_mem_a=dump_mem_w*dump_mem_h;
function dump_mem() {
  var s='';
  var w=dump_mem_w;
  var h=dump_mem_h;
  var c=0;    // char
  var d='';   // display char
  var hx= ''; // hex values string
  var as= ''; // ascii values string
  var of= Math.round(memScroll.dragger.posY*(0xFFFF-(dump_mem_a-w)))&(0xFFFF-w+1);
  for (var j=0;j<h;j++) {
    s+=where_mem(of)+':';
    s+=zf(hex(of),4)+'&nbsp; ';
    hx='';
    as='';
    for (var i=0;i<w;i++) {
      hx+=zf(hex(MEM[of+i]),2)+' ';
      c=MEM[of+i];
      d=String.fromCharCode(c);
      if (c>126) d='.';
      else if (c<32) d='.';
      else if (c==60) d='&lt;';
      else if (c==62) d='&gt;';
      else if (c==32) d='&nbsp;';
      as+=d;
    }  
    s+=hx+' '+as+'&nbsp;';
    s+=br;
    of+=w;
  }
  $('MEMDUMP').innerHTML=s;
}

// DISASSEMBLER + BREAKPOINTS STUFF //

function goto_asm(a) {
  a='0x'+a;
  asmScroll.dragger.setpos(0,((a-10<0)?0:(a-10))/(0xFFFF-dump_asm_h+1));
  dump_asm();
}

function saveBRK(ba) {
  var date = new Date(); date.setTime(date.getTime()+(30*24*60*60*1000));
  var expires = "; expires="+date.toGMTString();
  ba=(ba.length>0)?ba.join(','):'';
  //document.title='COOKIE WRITE:'+ba;
  document.cookie = 'JSGB_BRKP='+ba+expires+"; path=/";
}

function readBRK() {
  var n='JSGB_BRKP=';
  var ca = document.cookie.split(';');
  for(var i in ca) {
    var c = ca[i];
    while (c.charAt(0)==' ') c=c.substring(1,c.length);
    if (c.indexOf(n)==0) {
      var ba=c.substring(n.length,c.length);
      //document.title='COOKIE READ:'+ba;
      if(ba=='')return [];
      ba=ba.split(',');
      for(var j in ba) ba[j]*=1;
      return ba;
    }  
  }
  return [];
}

var BRK = readBRK();

function setBRK(addr) {
  addr*=1; // convert to integer
  var i=BRK.indexOf(addr);  
  if (i<0) BRK.push(addr);// Set breakpoint
  else BRK.splice(i,1); // Remove breakpoint
  saveBRK(BRK);
  dump_asm();
}

function clearBRK() {
  BRK=[];
  saveBRK(BRK);
  dump_asm();
}

function showcode(PC) {alert((MEM[PC]==0xCB)?OPCB[MEM[PC+1]]:OP[MEM[PC]]);}

var dump_asm_h = 40;
function dump_asm() {
  var s='';
  var oPC=PC;
  var of=0;
  var id='';
  var st='';
  PC=Math.round(asmScroll.dragger.posY*(0xFFFF-dump_asm_h+1));
  if (PC<=0) PC=0;
  for (var i=0;i<dump_asm_h;i++) {
    id='ASM_'+PC;
    st=(BRK.indexOf(PC)>=0)?' class="BK"':'';
    st+=(oPC==PC)?' style="background:#9F9;"':'';
    s+='<div id="'+id+'"'+st+'>';
    s+='<span onclick="showcode('+PC+');" class="CP U CB80">fn</span> ';
    s+='<span onclick="setBRK('+PC+');" class="CP C800">';
    s+=zf(hex(PC),4)+': ';
    s+=zf(hex(MEM[PC]),2)+' = ';
    s+=MN[MEM[PC]]();    
    s+='</span></div>\n';
    PC++;
  }
//else s+='<div>&nbsp;</div>\n';
  $('ASMDUMP').innerHTML=s;  

  PC=oPC;
}

// BACKGROUND //

function dump_bg() {
  draw_background();
/*
Bit 7: LCD Control Operation (0:Stop (no picture on screen)/1:operation)
Bit 6: Window Tile Map Display Select (0:$9800-$9BFF/1:$9C00-$9FFF)
Bit 5: Window Display (0:off/1:on)
Bit 4: BG & Window Tile Data Select (0:$8800-$97FF/1:$8000-$8FFF<-Same area as OBJ)
Bit 3: BG Tile Map Display Select (0:$9800-$9BFF/1:$9C00-$9FFF)
Bit 2: OBJ (Sprite) Size (0:8*8/1:8*16) (width*height)
Bit 1: OBJ (Sprite) Display (0:off/1:on)
Bit 0: BG & Window Display (0:off/1:on)
*/
  var b=0;
  var s='BG/Win info @ LCDC Reg'+br;
  b=(MEM[0xFF40]>>4)&1;
  s+='bit4='+b+'; Tile data = '+((b==0)?'0x8800-0x97FF':'0x8000-0x8FFF')+br;

  b=(MEM[0xFF40]>>3)&1;
  s+='bit3='+b+'; Tile map = '+((b==0)?'0x9800-0x9BFF':'0x9C00-0x9FFF')+br;

  b=(MEM[0xFF40]>>0)&1;
  s+='bit0='+b+'; Display = '+((b==0)?'off':'on')+br;
  $('BG_INFO').innerHTML=s;
}

// SPRITES //

function dump_sp() {
  var s='Sprite info @ LCDC Reg'+br;
  var b=(MEM[0xFF40]>>2)&1;
  s+='bit2='+b+'; Sprite size='+((b==0)?'8x8':'8x16')+br;
  $('SP_INFO').innerHTML=s;
}

// COMMON //

var memScroll;
var asmScroll;

function init_debugger() {
  memScroll = new scrollBar('MEMSCROLL',dump_mem);
  asmScroll = new scrollBar('ASMSCROLL',dump_asm);
}
