/* 
 * jsgb.graphics.js v0.02 - Timers functions for JSGB, a GameBoy Emulator
 * Copyright (C) 2009 Pedro Ladaria <Sonic1980 at Gmail dot com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 * The full license is available at http://www.gnu.org/licenses/gpl.html
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 */
 
function DIV_CONTROL() { // (GB Freq/DIV freq)=(4194304/16384)=256 cpu cicles
  DCC+=ICC;
  if (DCC>255) {
    DCC-=256;
    MEM[0xFF04]=(MEM[0xFF04]+1)&0xFF; // inc DIV
  }    
}

function TIMER_CONTROL() {
  if(MEM[0xFF07]&4) { // check TAC bit 2 (1:on/0:off)
    TCC+=ICC; // increment TimerClocksCounter
    if(TCC>TMC) { // if overflows...
      TCC-=TMC;
      if(MEM[0xFF05]>254) { // TIMA is going to overflow
        MEM[0xFF05]=MEM[0xFF06]; // set TIMA = TMA
        MEM[0xFF0F]|=4; // set IF bit 2
     }
     else MEM[0xFF05]++; // increment timer
    }
  }
}
